;Dialogs:
Dialog Fserv.dirinfo {
  title "Directory Info For The File Servers"
  size -1 -1 250 200
  option dbu

  tab "Dirinfo", 100, 3 2 240 165
  tab "Help", 101

  button "Save",1,130 170 25 17, OK
  button "Exit",2,95 170 25 17, Cancel

  Edit "" ,20, 5 35 230 125,multi return vsbar hsbar tab 100
  Edit "",21, 5 20 170 10, autovs read tab 100

  Link "File Server Script v4.4 by Yochai Timmer", 30,5 20 210 14,tab 101
  text "Dirinfo is a actually a file you add to the directory you want." ,22, 5 40 170 10 ,tab 101
  text "This file contains text that you put there with this dialog.",23, 5 50 170 10 ,tab 101
  text "The text will be shown every time the user does the Dir command when he's in that directory.",24,  5 60 220 10 ,tab 101
  text "It's advised that you put usefull information about the contents of important directories",25,  5 70 200 10 ,tab 101

  Menu "&Options" ,10
  Item "Save Dirinfo",11
  Item "Remove Dirinfo",12
  Item break,15
  Item "Load Dirinfo",13
  Item "Remove Dir's Dirinfo",14 
  Menu "&About",16
  Item "Yochai Timmer",17

}
on *:DIALOG:Fserv.dirinfo:init:*: {
  did -ra Fserv.dirinfo 21 $mircdir
  if ($findfile($mircdir,dirinfo.srv,1,1)) dloadbuf Fserv.dirinfo 20 $mircdir\dirinfo.srv
}
on *:DIALOG:Fserv.dirinfo:sclick:*: {
  if ($did = 30) run http://yochai.timmer.com
  if ($did = 1) && ($did(20).edited = $true) {
    write -c $did(21) $+ dirinfo.srv
    var %temp = 0 
    :start
    inc %temp
    if (%temp > $did(20).lines) return
    write $did(21) $+ dirinfo.srv $did(20,%temp)
    goto start
  }
}
on *:DIALOG:Fserv.dirinfo:menu:*: {
  if ($did = 12) {
    did -r Fserv.dirinfo 20
    .remove $did(21) $+ dirinfo.srv
  }
  if ($did = 13) {
    .timer 1 0 fs-menu13 $did(21)
  }
  if ($did = 14) {
    .timer 1 0 fs-menu14 $did(21)
  }
  if ($did = 17) {
    run Http://yochai.timmer.com
  } 
  if ($did = 11) && ($did(20).edited = $true) {
    write -c $did(21) $+ dirinfo.srv
    var %temp = 0 
    :start
    inc %temp
    if (%temp > $did(20).lines) return
    write $did(21) $+ dirinfo.srv $did(20,%temp)
    goto start
  }
}
dialog Fserv.setup {
  title "File Server Setup"
  size -1 -1 180 120
  option dbu

  tab "File Servers", 100, 3 2 175 115
  tab "Help", 101

  button "Done",1,100 95 25 20, OK
  button "Cancel",2,65 95 25 20, Cancel

  text "Trigger :",6, 5 20 64 8,tab 100
  edit "",7,60 19 75 10,tab 100
  text "File server directory :",8, 5 30 70 8,tab 100
  edit "",9, 60 29 75 10,autohs tab 100
  button "..", 10, 137 30 8 8, tab 100
  text "Welcome message :",11, 5 40 50 8,tab 100
  edit "",12,60 39 75 10,autohs tab 100
  button "..", 13, 137 40 8 8, tab 100 
  text "Description :",14, 5 50 70 8,tab 100
  edit "",15,60 49 75 10,autohs tab 100
  text "Count date :",16, 5 60 70 8,tab 100
  edit "",17,60 59 40 10,autohs read tab 100
  text "Count :",18, 5 70 40 8,tab 100
  edit "",19,60 69 20 10,autohs read tab 100
  button "Reset", 20, 85 70 25 8, tab 100
  Text "Label :", 21, 5 80 40 8,tab 100
  edit "",22,60 79 70 10,autohs read tab 100

  link "File Server Script v4.4 by Yochai Timmer",30,5 20 210 14,tab 101
  Text "Trigger -=>" 31,5 40 170 10, tab 101
  edit  "Here you should enter the trigger you want to use for users to load the File Server ",32,35 39 140 10,autohs read tab 101
  Text "File server directory -=>" 33,5 50 170 10, tab 101
  edit  "Here you should choose the File Directory where you want the File Server to serv from",34,60 49 115 10,autohs read tab 101
  Text "Welcome message -=>" 35,5 60 170 10, tab 101
  edit  "Here you should choose the welcome message that will be shown when a user requests a File Server ",36,60 59 115 10,autohs read tab 101
  Text "Description -=>" 37,5 80 170 10, tab 101
  edit  "Here you should enter description on what you're serving in the File Server ",48,45 79 130 10,autohs read tab 101
  Text "Count -=>" 39,5 70 170 10, tab 101
  edit  "Here you can see the trigger counter, and when it started counting. You can click on Reset to reset the counter ",40,65 69 110 10,autohs read tab 101

}
on *:DIALOG:Fserv.setup:init:*: {
  var %temp = $_Read-Setup(Temp-Name)
  did -ra Fserv.setup 7 $readini Fserver.ini %temp Trigger
  did -ra Fserv.setup 9 $readini Fserver.ini %temp Directory
  did -ra Fserv.setup 12 $readini Fserver.ini %temp Welcome
  did -ra Fserv.setup 15 $readini Fserver.ini %temp Description
  if ( [ $readini Fserver.ini %temp Date ] ) did -ra Fserv.setup 17 $readini Fserver.ini %temp Date
  else did -ra Fserv.setup 17 $asctime(dd/mmm/yyyy)
  if ( [ $readini Fserver.ini %temp Count ] ) && ( [ $readini Fserver.ini %temp Count ] != 0 ) did -ra Fserv.setup 19  $readini Fserver.ini %temp Count
  if ( [ $readini Fserver.ini %temp Label ] ) did -ra Fserv.setup 22 $readini Fserver.ini %temp Label 
  else did -ra Fserv.setup 19 0
  dialog -t Fserv.setup %temp
}
on *:DIALOG:Fserv.setup:sclick:*: {
  if ($did == 30) run Http://Yochai.timmer.com
  if ( $did == 10 ) bugfix did -ra Fserv.setup 9 ``sdir="Select File server directory:"
  if ( $did == 13 ) bugfix did -ra Fserv.setup 12 ``dir="Select Welcome message file:" $scriptdir*.txt
  if ( $did == 20 ) {
    did -ra Fserv.setup 17 $asctime(dd/mmm/yyyy)
    did -ra Fserv.setup 19 0
  }
  if ($did == 1) {
    if ($did(7)) writeini -n Fserver.ini $dialog(Fserv.setup).title Trigger $did(7)
    if ($did(9)) && ($exists($did(9)) = $true) {
      writeini -n Fserver.ini $dialog(Fserv.setup).title Directory $did(9)
      if ($did(9).edited = $true) && ($disk($did(9)).label) writeini -n Fserver.ini $dialog(Fserv.setup).title Label $disk($did(9)).label
    }
    if ($did(12)) && ($exists($did(12)) = $true) writeini -n Fserver.ini $dialog(Fserv.setup).title Welcome $did(12)
    if ($did(15)) writeini -n Fserver.ini $dialog(Fserv.setup).title Description $did(15)
    if ($istok($_Read-Setup(Fserv-names),$dialog(Fserv.setup).title,255) == $false)  {
      writeini -n Fserver.ini Setup Fserv-names $addtok($_Read-Setup(Fserv-names),$dialog(Fserv.setup).title,255)
      if ($disk($did(9)).label) writeini -n Fserver.ini $dialog(Fserv.setup).title Label $disk($did(9)).label
    }  
    if ($did(17)) writeini -n Fserver.ini $dialog(Fserv.setup).title Date $did(17)
    if ($did(19).edited) writeini -n Fserver.ini $dialog(Fserv.setup).title Count $did(19)
    if ( [ $readini Fserver.ini $dialog(Fserv.setup).title Label ] = $null ) && ($disk($did(9)).label) writeini -n Fserver.ini $dialog(Fserv.setup).title Label $disk($did(9)).label
    dialog -x Fserv.setup
    aline.Fserver.stats 
  }
}

dialog Advertise.List {
  title "Advertise List"
  size -1 -1 180 135
  option dbu

  tab "Advertise List", 21, 3 2 175 135
  tab "Help", 22

  button "Done",1,100 110 25 20, OK
  button "Cancel",2,70 110 25 20, Cancel

  text "Delay between the adds (In seconds) :",4, 5 20 170 8,tab 21
  edit "",5,100 19 50 10,autohs tab 21
  text "Channels on advertise list :",6, 5 30 170 8,tab 21
  combo 7, 5 40 80 70,vsbar edit sort tab 21 
  button "Add Channel",8,98 40 60 10, tab 21 
  button "Remove Channel",9,98 50 60 10, tab 21 
  text "Automaticly Start Advertising ",38, 98 65 70 8,tab 21
  text "on joining 1st channel.",39, 98 75 70 8,tab 21
  check "",40, 125 85 10 10, tab 21
  Link "File Server Script v4.4 by Yochai Timmer", 3,5 20 210 14,tab 22
  Text "Delay between the adds -=>",31,5 40 170 8,tab 22
  Edit  "Here you should enter the delay in seconds between the Advertises that will be shown on the chan (Must be over 60 !!)",32,75 39 100 10,autohs read tab 22
  Text "Channels on advertise list -=>",33,5 50 170 8,tab 22
  Edit  "Here you should enter a channel you want to Add or Remove from the Advertise List, Then click on Add Channel or Remove Channel as your choise.",34,75 49 100 10,autohs read tab 22
}
on *:DIALOG:Advertise.List:init:*: {
  if ( $numtok($_Read-Setup(Chans),255) > 0) didtok -a Advertise.List 7 255 $_Read-Setup(Chans)
  did -a Advertise.List 5 $_Read-Setup(Ad-Delay)
  if ($group(#FS_Auto-Ad) = on) did -c Advertise.List 40
}
on *:DIALOG:Advertise.List:sclick:*: { 
  if ($did == 30) run Http://Yochai.timmer.com
  if ($did == 8) {
    if ( $left($did(7),1) == $chr(35) ) || ( $left($did(7),1) == $chr(38) ) {
      if ($istok($_Read-Setup(Chans),$did(7),255) == $false) {
        writeini -n Fserver.ini Setup Chans $addtok($_Read-Setup(Chans),$did(7),255)
        did -a Advertise.List 7 $did(7)
        if ($timer(Fservadd)) {
          writeini -n Fserver.ini Setup How-Ad describe $replace($deltok($_Read-Setup(Chans),$len($_Read-Setup(Chans)),255),$chr(255),$chr(44))
        }
      } 
    }
  }
  if ($did == 9) {
    if ($istok($_Read-Setup(Chans),$did(7),255) == $true) {
      if ( $remtok($_Read-Setup(Chans),$did(7),1,255) ) {
        writeini -n Fserver.ini Setup Chans $remtok($_Read-Setup(Chans),$did(7),1,255)
        if ($timer(Fservadd)) writeini -n Fserver.ini Setup How-Ad describe $replace($deltok($_Read-Setup(Chans),$len($_Read-Setup(Chans)),255),$chr(255),$chr(44))
      }
      else {
        writeini -n Fserver.ini Setup Chans $chr(255)
        if ($timer(Fservadd)) .timerFservadd off
      }
      did -r Advertise.List 7
      if ( $numtok($_Read-Setup(Chans),255) > 0) didtok -a Advertise.List 7 255 $_Read-Setup(Chans)
    }
  } 
  if ($did == 1) {
    if ($did(40).state = 1) .enable #FS_Auto-Ad
    else .disable #FS_Auto-Ad
    if ($did(5) != $_Read-Setup(Ad-Delay)) {
      writeini -n Fserver.ini Setup Ad-Delay $did(5)
      if ($timer(fservadd)) {
        .timerFservadda off
        .timerFservadd -ra 0 $_Read-Setup(Ad-Delay) Fs-advertise-ad
      }
      if ($timer(fservadda)) {
        .timerFservadd off
        .timerFservadda -ra 0 $_Read-Setup(Ad-Delay) $!Fserv.ad
      }
      aline.Fserver.chans
      aline -p @F-serverSetup 12Due to the fact you've changed the Timer's Delay...
      aline -p @F-serverSetup 12The advertise timers have been restarted, and set to run on the new Delay value.
    }
  }
}

dialog Fserver.Options {
  title "File Server Script Options"
  size -1 -1 180 140
  option dbu

  tab "General", 21, 3 2 175 135
  tab "Advertise", 22

  button "Done",1,90 115 25 20, OK
  button "Cancel",2,60 115 25 20, Cancel

  text "Count date :",3, 5 20 70 8,tab 21
  edit "",4,40 19 40 10,autohs read tab 21
  text "Count :",5, 5 30 40 8,tab 21
  edit "",6,30 29 20 10,autohs read tab 21
  text "Sent :",7, 55 30 40 8,tab 21
  edit "",8,75 29 20 10,autohs read tab 21
  button "Reset", 9, 100 30 25 8, tab 21
  text "Max Sends :",10, 5 50 70 8,tab 21
  edit "",11,65 49 20 10,autohs tab 21
  text "Max Sends Per User :",12, 5 60 60 8,tab 21
  edit "",13,65 59 20 10,autohs tab 21
  text "Max Ques :",14, 5 75 70 8,tab 21
  edit "",15,65 74 20 10,autohs tab 21
  text "Ques per User :",16, 5 85 40 8,tab 21
  edit "",17,65 84 20 10,autohs tab 21
  text "Max File Servers Online :",18, 5 100 60 8,tab 21
  edit "",19,65 99 20 10,autohs tab 21

  text "Show number of files in File Server.",31, 5 20 100 8,tab 22
  check "",41, 125 20 10 10, tab 22
  text "Show File Server triggers.",32, 5 30 100 8,tab 22
  check "",42, 125 30 10 10, tab 22
  text "Show number of open File Servers.",33, 5 40 100 8,tab 22
  check "",43, 125 40 10 10, tab 22
  text "Show number of Ques available.",34, 5 50 100 8,tab 22
  check "",44, 125 50 10 10, tab 22
  text "Show number of open slots.",35, 5 60 100 8,tab 22
  check "",45, 125 60 10 10, tab 22
  text "Show counters info.",36, 5 70 50 8,tab 22
  check "",46, 125 70 10 10, tab 22
  text "Show that you have a File List.",37, 5 80 100 8,tab 22
  check "",47, 125 80 10 10, tab 22
  text "Show that you serv with channel commands.",38, 5 90 110 8,tab 22
  check "",48, 125 90 10 10, tab 22
}
on *:DIALOG:Fserver.Options:init:*: {
  did -ra Fserver.Options 4 $_Read-Setup(Date)
  did -ra Fserver.Options 6 $_Read-Setup(Count)
  did -ra Fserver.Options 8 $_Read-Setup(Sent)
  did -ra Fserver.Options 11 $_Read-Setup(Max-Sends)
  did -ra Fserver.Options 13 $_Read-Setup(Sends/User)
  did -ra Fserver.Options 15 $_Read-Setup(Max-Ques)
  did -ra Fserver.Options 17 $_Read-Setup(Ques/User)
  did -ra Fserver.Options 19 $_Read-Setup(Max-Fserv)
  var %fileserv.check = 0
  while ( %fileserv.check != 8 ) {
    inc %fileserv.check
    if ( $gettok($_Read-Setup(Ad-code),%fileserv.check,32) == 1 ) did -c Fserver.Options 4 [ $+ [ %fileserv.check ] ]
  }
}
on *:DIALOG:Fserver.Options:sclick:*: {
  if ($did == 9) {
    did -ra Fserver.Options 4 $asctime(dd/mmm/yyyy)
    did -ra Fserver.Options 6,8 0
  }
  if ($did == 1) {
    if ($did(4)) writeini -n Fserver.ini Setup Date $did(4)
    if ($did(6).edited) writeini -n Fserver.ini Setup Count $did(6)
    if ($did(8).edited) writeini -n Fserver.ini Setup Sent $did(8)
    if ($did(11)) writeini -n Fserver.ini Setup Max-Sends $did(11)
    if ($did(13)) writeini -n Fserver.ini Setup Sends/User $did(13)
    if ($did(15)) writeini -n Fserver.ini Setup Max-Ques $did(15)
    if ($did(17)) writeini -n Fserver.ini Setup Ques/User $did(17)
    if ($did(19)) writeini -n Fserver.ini Setup Max-Fserv $did(19)
    var %fileserv.check = 0
    while ( %fileserv.check != 8 ) {
      inc %fileserv.check
      writeini -n Fserver.ini Setup Ad-code $puttok($_Read-Setup(Ad-code),$did(4 [ $+ [ %fileserv.check ] ] ).state,%fileserv.check,32)
    }
    aline.Fserver.stats 
  }
}
;Dialog Bugfix:
alias -l bugfix { write -cn $scriptdirbugfix.tmp $replace($1-,~,%,`,$) $chr(124) .timer 1 0 .remove $scriptdirbugfix.tmp | .play -spc $scriptdirbugfix.tmp 0 }
alias -l Dloadbuf {
  if ($3) {
    var %temp = $lines($3-)
    var %i = 0
    did -r $1 $2
    :start
    inc %i 
    if (%i <= %temp) {
      did -i $1 $2 %i $read -l $+ %i " $+ $3- $+ " 
      goto start
    }
    halt
  }
}
alias -l fs-menu13 {
  var %temp = $sdir="Select a directory to edit the Dirinfo" $1
  did -ra Fserv.dirinfo 21 %temp
  did -r Fserv.dirinfo 20
  if ($findfile(%temp,dirinfo.srv,1,1)) dloadbuf Fserv.dirinfo 20 %temp $+ dirinfo.srv
}
alias -l fs-menu14 {
  var %temp = $sdir="Select a directory to edit the Dirinfo" $1
  if (%temp) { 
    var %temp2 = $?!="Are you sure you wanna remove the Dirinfo from this directory ? %temp "
    if (%temp2 = $true) {
      .remove %temp $+ Dirinfo.srv
      if ($1 = %temp) did -r Fserv.dirinfo 20
    }
  }
}
